procedure TForm1.btnGetBlogContentsClick(Sender: TObject);
const
  KeyIdentifier = 'bBwPfItvKp3b6TNDq+14qs58VJQ=';
var
  x509Token: X509SecurityToken;
  x509Store: X509CertificateStore;
  x509Certs: X509CertificateCollection;
var
  WS: TSecureBlog;
  Last: Integer;
  Token: UsernameToken;
begin
  WS := TSecureBlog.Create;
  x509Token := nil;
  x509Store := X509CertificateStore.CurrentUserStore('My');
  if x509Store.OpenRead then
  begin
    x509Certs := x509Store.FindCertificateByKeyIdentifier(
      Convert.FromBase64String(KeyIdentifier));
    if x509Certs.Count > 0 then
      x509Token := x509SecurityToken.Create(x509Certs[0])
  end;
  if Assigned(x509Token) then
  begin
    WS.RequestSoapContext.Security.Tokens.Add(x509Token);
    WS.RequestSoapContext.Security.Elements.Add(
      Signature.Create(x509Token));
    WS.RequestSoapContext.Security.Elements.Add(
      EncryptedData.Create(x509Token));
  end
  else
  begin
    Token := UsernameToken.Create('Bob', 'Swart', PasswordOption.SendHashed);
    WS.RequestSoapContext.Security.Tokens.Add(Token);
    WS.RequestSoapContext.Security.Elements.Add(Signature.Create(Token));
  end;
  // token will remain part of the TSecureBlog instance in WS
  Last := WS.NumberOfPosts;
  if Last > 0 then
  try
    Memo1.Text := WS.GetPostContent(Last-1);
  except
    on E: Exception do
      Memo1.Text := E.Message
  end
  else
    Memo1.Text := 'Number of Posts = 0'
end;
