function TSecureBlog.CheckSignature: Boolean;
var
  element: ISecurityElement;
  sig: MessageSignature;
begin
  HttpContext.Current.Trace.Write('TSecureBlog.CheckSignature');
  Result := False;
  if Assigned(RequestSoapContext.Current) then // SOAP request
    if Assigned(RequestSoapContext.Current.Security) then
    begin
      HttpContext.Current.Trace.Write('SOAP Security: ' +
        RequestSoapContext.Current.Security.Elements.Count.ToString);
      for element in RequestSoapContext.Current.Security.Elements do
      begin
        if element is MessageSignature then
        begin
          sig := element as MessageSignature;
          Result := True // only if request was signed!
        end
        else HttpContext.Current.Trace.Write('not a signature')
      end
    end
    else HttpContext.Current.Trace.Write('no security')
  else HttpContext.Current.Trace.Write('not a SOAP request');
  HttpContext.Current.Trace.Write('TSecureBlog.CheckSignature END');
end;

function TSecureBlog.CheckEncrypted: Boolean;
var
  element: ISecurityElement;
  enc: EncryptedData;
begin
  HttpContext.Current.Trace.Write('TSecureBlog.CheckEncrypted');
  Result := False;
  if Assigned(RequestSoapContext.Current) then // SOAP request
    if Assigned(RequestSoapContext.Current.Security) then
    begin
      HttpContext.Current.Trace.Write('SOAP Security: ' +
        RequestSoapContext.Current.Security.Elements.Count.ToString);
      for element in RequestSoapContext.Current.Security.Elements do
      begin
        if element is EncryptedData then
        begin
          enc := element as EncryptedData;
          Result := True // only if request was encrypted!
        end
        else HttpContext.Current.Trace.Write('not encryption')
      end
    end
    else
      HttpContext.Current.Trace.Write('no security')
  else
    HttpContext.Current.Trace.Write('not a SOAP request');
  HttpContext.Current.Trace.Write('TSecureBlog.CheckEncrypted END');
end;
