function TSecureBlog.NumberOfPosts: Integer;
begin // SOAP request must be signed
  HttpContext.Current.Trace.Write('TSecureBlog.NumberOfPosts');
  if CheckSignature then
  begin
    Result := 1
  end
  else Result := 0;
end;

function TSecureBlog.GetPostTitle(Post: Integer): String;
begin // SOAP request must be signed
  HttpContext.Current.Trace.Write('TSecureBlog.GetPostTitle');
  if (Post >= 0) and (Post < NumberOfPosts) then
    if CheckEncrypted then
      Result := 'SOAP, Web Services and Security'
    else
      Result := 'Request not encrypted!'
  else
    Result := 'n/a'
end;

function TSecureBlog.GetPostContent(Post: Integer): String;
begin // SOAP request must be signed and authenticated
  HttpContext.Current.Trace.Write('TSecureBlog.GetPostContent');
  if (Post >= 0) and (Post < NumberOfPosts) then
  begin
    if CheckBlogCredentials then
    begin
      if CheckEncrypted then
        Result := 'Read The Delphi Magazine #124 for the full article!'
      else
        Result := 'Request not encrypted!'
    end
    else
      Result := 'Permission denied!'
  end
  else
    Result := 'n/a'
end;
